Subject: Re: Feature Launcher status ( 2024/09/23 )
From: "Michael H. Siemaszko" <[email-masked]>
To: "Timothy Ward" <[email-masked]>
Date: Mon, 23 Sep 2024 12:59:09 +0000

Hi Tim,

Before our today's meeting, I am sending along list of questions I wanted to ask.

Status is known to you from last week's PR, its review, and subsequent fixes applied. As mentioned, I am focusing the next items, to make it on time with the demo project.

Questions I have are the following:

1) Regarding priorities in implementation - I deliberately first chose ( and implemented or am in the process of implementing ) those functionalities which are needed for demo project, as per your outline of what that project is supposed to demonstrate, i.e.:

- Launching framework
* Launching a framework with a "simple" feature, containing bundles and configurations, with no start levels and no framework selection
* Launching a framework with a feature which selects a framework implementation, with no start levels

- Installing features at runtime
* Installing a "simple" feature, with no start levels
* Installing a second feature with overlapping bundles

- Updating features at runtime
* Simple update showing version changes in some of the bundles

- Removing features
* A simple uninstallation case

Please confirm and supplement if necessary, as that's how priorities are set currently.

2) Continuing re: demo project - aside from your outline of what that project is supposed to demonstrate, how is user supposed to interact ? I.e. via GUI ? Via CLI ? If CLI, how is "Add the Command line client" ( https://github.com/kentyou/feature-launcher-prototype/issues/21 ) related to this ?

3) Please clarify regarding "160.4.3.2: #1. If any provider specific configuration has been given to the Feature Launcher implementation then this should be used to identify the framework" - this is not clear to me, the other items in that section are clear enough; relevant class is `com.kentyou.featurelauncher.impl.util.FrameworkFactoryLocator`

4) Custom exceptions instead of re-throwing as RunTimeException - e.g. @ `com.kentyou.featurelauncher.impl.repository.LocalArtifactRepositoryImpl` - API / specification does not define custom exception in case of exception thrown during `com.kentyou.featurelauncher.impl.repository.LocalArtifactRepositoryImpl.getArtifact(ID)` operation; should there such ?

5) Should CI/CD be set up for this project ? If yes, should GitHub actions be used or integrate with some other build server ?

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 9/18/24 22:20, Timothy Ward wrote:

A call to report status, highlight any blocking issues, and provide feedback on the specification

________________________________________________________________________________

Microsoft Teams Need help?

Join the meeting now

Meeting ID: 368 661 349 750

Passcode: VWT4Yy

For organisers: Meeting options

________________________________________________________________________________